/*-
 * ~~~~~~licensing~~~~~~
 * cluster-node-management
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.management.cluster.node.impl;

import javax.management.NotCompliantMBeanException;

import com.hazelcast.core.Member;

import ru.entaxy.esb.platform.base.management.core.api.AnnotatedMBean;
import ru.entaxy.esb.platform.core.management.node.ClusterNodeMBean;

public class ClusterNodeMBeanImpl extends AnnotatedMBean<ClusterNodeMBean> implements ClusterNodeMBean {

	protected MemberAwareDataProvider dataProvider;
	
	protected ClusterNodeMBeanImpl(Member member, ServiceHelper serviceHelper) throws NotCompliantMBeanException {
		super(ClusterNodeMBean.class);
		this.dataProvider = new MemberAwareDataProvider(member, serviceHelper);
	}

	@Override
	public String getEntaxyPlatformVersion() {
		return dataProvider.getEntaxyPlatformVersion();
	}

	@Override
	public String getHttpPort() {
		return dataProvider.getHttpPort();
	}

	@Override
	public String getSshPort() {
		return dataProvider.getSshPort();
	}

	@Override
	public boolean isUIEnabled() {
		return dataProvider.isUIEnabled();
	}

	@Override
	public boolean isClusterEnabled() {
		return dataProvider.isClusterEnabled();
	}

	@Override
	public String getClusterIP() {
		return dataProvider.getClusterIP();
	}

	@Override
	public String getClusterPort() {
		return dataProvider.getClusterPort();
	}

	@Override
	public String getNodeId() {
		return dataProvider.getNodeId();
	}
	
	@Override
	public boolean isConsumerStarted() {
		return dataProvider.isConsumerStarted();
	}
	
	@Override
	public boolean isProducerStarted() {
		return dataProvider.isProducerStarted();
	}
}
